var m_fullUrl = "http://msn.foxsports.com/nugget/12";

var m_gameId;
var m_gameData;

var m_periods = ["1", "2", "3", "OT", "SH"];

function loadFlyout()
{
    Localize();

    // get the current item from the dock
    m_gameId = System.Gadget.document.parentWindow.m_flyGame;

    if (m_gameId == null)
    {
        ShowNoGame();
    }
    else
    {
        GetGameInfo();
    }
}

function Localize()
{
}

function ShowLoading()
{
    noGame.style.display = "none";
    content.style.display = "none";
    loading.style.display = "block";
}

function ShowNoGame()
{
    content.style.display = "none";
    loading.style.display = "none";
    noGame.style.display = "block";
}

function ShowContent()
{
    loading.style.display = "none";
    noGame.style.display = "none";
    content.style.display = "block";
}

function GetGameInfo()
{
    var url = m_fullUrl + "?f=" + Math.random();

    var req = new XMLHttpRequest();
    req.open("GET", url);

    req.onreadystatechange = function()
    {
        if (req.readyState == 4)
        {
            // check to see if this is necessary with the sports feed
            var doc = new ActiveXObject("MSXML2.DOMDocument.3.0");
            doc.loadXML(req.responseText);
            m_gameData = ParseGameInfo(doc);

            DisplayGameInfo();
        }
    }

    ShowLoading();
    req.send();
}

function ParseGameInfo(p_doc)
{
    if (p_doc == null || p_doc.documentElement == null)
    {
        return null;
    }

    var game = p_doc.documentElement.selectSingleNode("//scores/league/game[@gameId=\"" + m_gameId + "\"]");

    if (game == null)
    {
        return null;
    }

    var status = game.selectSingleNode("@status").text;
    var date = game.selectSingleNode("@date").text;
    var startTime = game.selectSingleNode("@startTime").text;
    var gameUrl = "http://msn.foxsports.com" + game.selectSingleNode("links/gametracker/@url").text;
    var gamestate = game.selectSingleNode("@gamestate").text;

    var goals = new Array();
    goals["home"] = ParseGoals(game.selectSingleNode("gamestats/home"));
    goals["away"] = ParseGoals(game.selectSingleNode("gamestats/away"));
    
    var teams = new Array();
    teams["home"] = ParseTeam(game.selectSingleNode("home"));
    teams["away"] = ParseTeam(game.selectSingleNode("away"));

    return {
        status: status
        , date: date
        , startTime: startTime
        , gameUrl: gameUrl
        , goals: goals
        , teams: teams
        , gamestate: gamestate
    };
}

function ParseTeam(p_team)
{
    var id = p_team.selectSingleNode("@id").text;
    var name = p_team.selectSingleNode("@name").text;
    var city = p_team.selectSingleNode("@city").text;
    var standings = p_team.selectSingleNode("@standings").text;
    var url = "http://msn.foxsports.com" + p_team.selectSingleNode("@url").text;
    var alias = p_team.selectSingleNode("@alias").text;

    return {
        id: id
        , name: name
        , city: city
        , standings: standings
        , url: url
        , alias: alias
    };
}

function ParseGoals(p_goals)
{
    var totalGoals = p_goals.selectSingleNode("linescores/@totalscore").text;

    var goalNodes = p_goals.selectNodes("linescores/linescore");

    var goals;

    if (goalNodes == null || goalNodes.length == 0)
    {
        goals = null;
    }
    else
    {
        goals = new Array();
        for (var i = 0; i < goalNodes.length; i++)
        {
            var period = goalNodes[i].selectSingleNode("@period").text;
            goals[period] = goalNodes[i].selectSingleNode("@score").text;
        }
    }
    
    return {
        totalGoals: totalGoals
        , goals: goals
    };
}

function DisplayGameInfo()
{
    if (m_gameData == null)
    {
        ShowNoGame();
        return;
    }

    PopulateTeam(m_gameData.teams["away"], awayLink, awayLogo, awayGameLink, awayStandings);
    PopulateTeam(m_gameData.teams["home"], homeLink, homeLogo, homeGameLink, homeStandings);

    PopulateCenterData();

    ShowContent();
}

function PopulateTeam(p_teamInfo, p_link, p_logo, p_name, p_standings)
{
    p_link.href = p_teamInfo.url;
    p_logo.src = "images/teams/large/" + p_teamInfo.id + ".png";
    p_name.innerText = p_teamInfo.city + " " + p_teamInfo.name;
    p_name.href = m_gameData.gameUrl;
    p_standings.innerText = p_teamInfo.standings;
}

function PopulateCenterData()
{
    dateGameLink.innerText = m_gameData.date + " " + m_gameData.startTime;
    dateGameLink.href = m_gameData.gameUrl;

    if (m_gameData.gamestate != "Pre-Game")
    {
        PopulateScoreboard(m_gameData.goals["away"], m_gameData.teams["away"], "a", m_gameData.gamestate);
        PopulateScoreboard(m_gameData.goals["home"], m_gameData.teams["home"], "h", m_gameData.gamestate);
        scoreStatus.innerText = m_gameData.status;

        scoreboard.style.display = "block";
    }
    else
    {
        scoreboard.style.display = "none";
    }
}

function PopulateScoreboard(p_goals, p_team, p_prefix, p_gamestate)
{
    document.getElementById(p_prefix + "Name").innerText = p_team.alias.toUpperCase();

    for (var i = 0; i < m_periods.length; i++)
    {
        var field = document.getElementById(p_prefix + m_periods[i]);

        if (p_goals.goals[m_periods[i]] != null)
        {
            field.innerText = p_goals.goals[m_periods[i]];
        }
        else
        {
            if (i < 3 && p_gamestate == "In-Progress")
            {
                field.innerText = "--";
            }
            else
            {
                field.style.display = "none";
                document.getElementById("hdr" + m_periods[i]).style.display = "none";
            }
        }
    }

    document.getElementById(p_prefix + "Score").innerText = p_goals.totalGoals;
    
}

function onFlyoutKeyUp()
{
    // Close flyout on esc
    if (event.keyCode == 27)
    {
        OnCloseScoreboard();
    }
}

function OnCloseScoreboard()
{
    System.Gadget.Flyout.show = false;
}

function OnCloseOver()
{
    closebutton.src = "images/close_hover.png";
}

function OnCloseOut()
{
    closebutton.src = "images/close.png";
}