var m_briefUrl = "http://msn.foxsports.com/nugget/9240_142";
var m_gameData = null;
var m_gameCount = 0;

// refresh timer
var m_refreshTimer = null;
var m_refreshInterval = 300000; // every 5 minutes

// item height
var m_itemHeight = 49;
var m_pageHeight = m_itemHeight * 2;

// flyout game id
var m_flyGame = null;

function loadMain()
{
    // localize
    Localize();

    System.Gadget.Flyout.file = "flyout.html";
    System.Gadget.Flyout.onShow = flyoutShowing;
    System.Gadget.Flyout.onHide = flyoutHiding;

    System.Gadget.visibilityChanged = VisibilityChanged;

    GetScores(true);
    StartRefresh();

    document.body.focus();
}

function Localize()
{
    dataText.innerText = DOCK_DATA_TEXT;
    dataLink.innerText = DOCK_DATA_LINK;
}

function flyoutShowing()
{
    StopRefresh();
    docked.style.display = "none";
    flyoutDock.style.display = "block";
}

function flyoutHiding()
{
    StartRefresh();
    flyoutDock.style.display = "none";
    docked.style.display = "block";
    m_flyGame = null;
}

function ShowLoading(p_big)
{
    if (p_big == true)
    {
        noScores.style.display = "none";
        scoreScroll.style.display = "none";
        scrollIndicator.style.display = "none";
        loading.style.display = "block";
        smallLoading.style.display = "none";
    }
    else
    {
        loading.style.display = "none";
        smallLoading.src = "images/small_loading.gif";
        smallLoading.style.display = "inline";
    }
}

function ShowNoScores()
{
    scoreScroll.style.display = "none";
    loading.style.display = "none";
    smallLoading.style.display = "none";
    scrollIndicator.style.display = "none";
    noScores.style.display = "block";
}

function ShowScoreBox()
{
    noScores.style.display = "none";
    loading.style.display = "none";
    smallLoading.style.display = "none";
    scoreScroll.style.display = "block";
    scrollIndicator.style.display = "block";
}

function StartRefresh()
{
    if (m_refreshTimer == null)
    {
        m_refreshTimer = setInterval("GetScores(false)", m_refreshInterval);
    }
}

function StopRefresh()
{
    if (m_refreshTimer != null)
    {
        clearInterval(m_refreshTimer);
        m_refreshTimer = null;
    }
}

function VisibilityChanged()
{
    // We need to do this in order to re-start timers on resume from sleep
    if (System.Gadget.visible == true)
    {
        StartRefresh();
    }
    else
    {
        StopRefresh();
    }
}

function GetScores(p_first)
{
    var url = m_briefUrl + "?f=" + Math.random();

    var req = new XMLHttpRequest();
    req.open("GET", url);

    req.onreadystatechange = function()
    {
        if (req.readyState == 4)
        {
            // check to see if this is necessary with the sports feed
            var doc = new ActiveXObject("MSXML2.DOMDocument.3.0");
            doc.loadXML(req.responseText);
            m_gameData = ParseGames(doc);

            DisplayScores();
        }
    }

    ShowLoading(p_first);
    req.send();
}

function ParseGames(responseXML)
{
    // sanity
    if (responseXML == null || responseXML.documentElement == null)
    {
        return null;
    }

    var collection = null;
    var games = responseXML.documentElement.selectNodes("//games/game");

    if (games != null && games.length > 0)
    {
        m_gameCount = games.length;
        collection = new Array(games.length);

        for (var i = 0; i < games.length; i++)
        {
            var id = games[i].selectSingleNode("@gameId").text;
            var status = games[i].selectSingleNode("@gameStatus").text;
            var awayTeam = games[i].selectSingleNode("@awayTeam").text;
            var homeTeam = games[i].selectSingleNode("@homeTeam").text;
            var awayScore = games[i].selectSingleNode("@awayScore").text;
            var homeScore = games[i].selectSingleNode("@homeScore").text;
            var pregame = games[i].selectSingleNode("@pregame").text;

            collection[id] = {
                id: id
                , status: status
                , awayTeam: awayTeam
                , homeTeam: homeTeam
                , awayScore: awayScore
                , homeScore: homeScore
                , pregame: pregame
            };

            id = status = awayTeam = homeTeam = awayScore = homeScore = null;
        }
        
        games = null;
    }

    return collection;
}

function DisplayScores()
{
    if (m_gameData == null)
    {
        ShowNoScores();
        return;
    }

    // clear out the scorebox
    var scrollPos = ClearScoreBox();

    for (var i in m_gameData)
    {
        var div = document.createElement("div");
        scorebox.appendChild(div);
        div.className = "gameItem";
        div.id = m_gameData[i].id;

        var away = document.createElement("div");
        div.appendChild(away);
        away.className = "teamRow";

        var awayTeam = document.createElement("span");
        away.appendChild(awayTeam);
        awayTeam.className = "teamName";
        awayTeam.innerText = m_gameData[i].awayTeam.toUpperCase();
        awayTeam = null;

        if (m_gameData[i].pregame != "1")
        {
            var awayScore = document.createElement("span");
            away.appendChild(awayScore);
            awayScore.className = "teamScore";
            awayScore.innerText = m_gameData[i].awayScore;
            awayScore = null;
        }
        away = null;

        var home = document.createElement("div");
        div.appendChild(home);
        home.className = "teamRow";

        var homeTeam = document.createElement("span");
        home.appendChild(homeTeam);
        homeTeam.className = "teamName";
        homeTeam.innerText = m_gameData[i].homeTeam.toUpperCase();
        homeTeam = null;

        if (m_gameData[i].pregame != "1")
        {
            var homeScore = document.createElement("span");
            home.appendChild(homeScore);
            homeScore.className = "teamScore";
            homeScore.innerText = m_gameData[i].homeScore;
            homeScore = null;
        }
        home = null;

        var status = document.createElement("div");
        div.appendChild(status);
        status.className = "teamRow";
        status.innerText = m_gameData[i].status.toUpperCase();
        status = null;

        div = null;
    }

    var padding = 4 - m_gameCount % 4;
    for (var j = 0; j < padding; j++)
    {
        var div = document.createElement("div");
        scorebox.appendChild(div);
        div.className = "gameSpacer";
        div = null;
    }

    scorebox.scrollTop = Math.min(scrollPos, scorebox.scrollHeight - m_pageHeight);
    
    ShowScoreBox();
    UpdateScroll();
}

function UpdateScroll()
{
    // figure out how many pages and where we're at
    var pages = Math.ceil(scorebox.scrollHeight / m_pageHeight);
    var currentPage = Math.round(scorebox.scrollTop / m_pageHeight);

    // clear the indicator bits
    scrollIndicator.innerHTML = "";

    // add the indicator bits
    for (var i = 0; i < pages; i++)
    {
        var img = document.createElement("img");
        scrollIndicator.appendChild(img);
        img.className = "scrollBullet";

        if (i == currentPage)
        {
            img.src = "images/bullet_hi.png";
        }
        else
        {
            img.src = "images/bullet.png";
        }

        img = null;
    }

    UpdateScrollUp(pages, currentPage);
    UpdateScrollDown(pages, currentPage);
}

function UpdateScrollUp(p_pages, p_currentPage)
{
    if (p_currentPage > 0)
    {
        scrollup.src = "images/up_enabled.png";
        scrollup.style.cursor = "pointer";
    }
    else
    {
        scrollup.src = "images/up_disabled.png";
        scrollup.style.cursor = "default";
    }
}

function UpdateScrollDown(p_pages, p_currentPage)
{
    if (p_currentPage < p_pages - 1)
    {
        scrolldn.src = "images/down_enabled.png";
        scrolldn.style.cursor = "pointer";
    }
    else
    {
        scrolldn.src = "images/down_disabled.png";
        scrolldn.style.cursor = "default";
    }
}

function ClearScoreBox()
{
    // save the current scroll position
    var scrollPos = scorebox.scrollTop;
    
    // clear HTML
    scorebox.innerHTML = "";

    return scrollPos;
}

function OnGameClick(e)
{
    // use e.srcElement.id to trigger the flyout.
    // need to walk the stack to find the right src element
    if (e == null)
    {
        e = event;
    }

    var el = e.srcElement;

    while (el != null && el.className != "gameItem")
    {
        el = el.parentElement;
    }

    if (el != null)
    {
        m_flyGame = el.id;
        System.Gadget.Flyout.show = true;
    }
}

function OnScrollUp(e)
{
    scorebox.scrollTop = Math.max(scorebox.scrollTop - m_pageHeight, 0);
    UpdateScroll();
}

function OnScrollDown(e)
{
    scorebox.scrollTop = Math.min(scorebox.scrollTop + m_pageHeight, scorebox.scrollHeight - m_pageHeight);
    UpdateScroll();
}

function OnItemOver(e)
{
    if (e == null)
    {
        e = event;
    }

    var el = e.toElement;
    
    while (el != null && el.className != "gameItem")
    {
        el = el.parentElement;
    }
    
    if (el != null)
    {
        el.style.backgroundImage = "url(/images/itembg_hi.png)";
    }
}

function OnItemOut(e)
{
    if (e == null)
    {
        e = event;
    }

    var el = e.fromElement;
    
    while (el != null && el.className != "gameItem")
    {
        el = el.parentElement;
    }
    
    if (el != null)
    {
        el.style.backgroundImage = "url(/images/itembg.png)";
    }
}